Type.registerNamespace('JPAjaxControlToolKit');

JPAjaxControlToolKit.HierarchicalGridBehavior = function(element) {

    JPAjaxControlToolKit.HierarchicalGridBehavior.initializeBase(this, [element]);

    this._Row = "";
    this._ClickHandler = null;

}

JPAjaxControlToolKit.HierarchicalGridBehavior.prototype = {

    initialize : function() {
        JPAjaxControlToolKit.HierarchicalGridBehavior.callBaseMethod(this, 'initialize');

        var e = this.get_element();
        this._ClickHandler = Function.createDelegate(this, this._OnClick);
        $addHandler(e, 'click', this._ClickHandler);
        e.style.cursor = "pointer";
        e.src = this._ImageURLCollapsed;

        $get(this._PanelToCollapse).style.display="none";
        //this._CreateCollapsedRow($get(this._Row), $get(this._PanelToCollapse))
        this._CreateCollapsedRow(this._rowToCollapse, $get(this._PanelToCollapse))
        $get(this._PanelToCollapse).style.display="";
        
        if (!this._Collapsed) {
            //this._ToggleRow($get(this._Row));
            this._ToggleRow(this._rowToCollapse);
        }

    },

    dispose : function() {
        var e = this.get_element();

        if (this._ClickHandler != null){
            $removeHandler(e, 'click', this._ClickHandler);        
            this._ClickHandler = null;
        }

        JPAjaxControlToolKit.HierarchicalGridBehavior.callBaseMethod(this, 'dispose');
    },

    get_PanelToCollapse : function() {
        return this._PanelToCollapse;
    },

    set_PanelToCollapse : function(value) {
        this._PanelToCollapse = value;
    },

//    get_Row : function() {
//        return this._Row;
//    },

//    set_Row : function(value) {
//        this._Row = value;
//    },

    get_rowToCollapse : function() {
        return this._rowToCollapse;
    },

    set_rowToCollapse : function(value) {
        this._rowToCollapse = value;
    },

    get_ImageURLExpanded : function() {
        return this._ImageURLExpanded;
    },

    set_ImageURLExpanded : function(value) {
        this._ImageURLExpanded = value;
    },

    get_ImageURLCollapsed : function() {
        return this._ImageURLCollapsed;
    },

    set_ImageURLCollapsed : function(value) {
        this._ImageURLCollapsed = value;
    },

    get_Collapsed : function() {
        return this._Collapsed;
    },

    set_Collapsed : function(value) {
        this._Collapsed = value;
    },

    _OnClick : function() {
        //this._ToggleRow($get(this._Row))
        this._ToggleRow(this._rowToCollapse)
    },
    
    _CreateCollapsedRow : function(row, div) {
		if(row == null)
			return;

		//if the hidden row has not already been generated, clone the panel into a new row
		var existingRow = window.document.getElementById(row.id + "collapsedRow");
		if (existingRow==null)
		{
			//getting a reference to the table
			var table = this._GetParentElementByTagName(row, "TABLE");
			var index = row.sectionRowIndex + 1;
			//adding new row to table
			var newRow = table.insertRow(index);
			newRow.style.backgroundColor = row.style.backgroundColor;
			newRow.className = row.className; 
			newRow.id = row.id + "collapsedRow";

			//adding new cell to row
			var newTD=document.createElement("TD");
						
			//set the colspan to the number of columns
			var columnCount = row.cells.length; //TODO: Verificar se d problema quando tem colspan
			newTD.colSpan = columnCount - 1;
			
			div.parentNode.removeChild(div);
			newTD.appendChild(div);
			newRow.appendChild(newTD);
			
            this._ToggleRow(row)
		}
    
    },
    
    _ToggleRow : function (row) {
		var existingRow = window.document.getElementById(row.id + "collapsedRow");
		if (existingRow==null)
		    return;

        var e = this.get_element();
    
	    var cellimg = row.cells[0];
	    cellimg.style.verticalAlign = "top";

		if (existingRow.style.display=="none")
		{
		    cellimg.rowSpan = 2;
			existingRow.style.display = "";
			e.src = this._ImageURLExpanded;
		}
		else
		{
		    cellimg.rowSpan = 1;
			existingRow.style.display = "none";
			e.src = this._ImageURLCollapsed;
		}
    },
    
    _GetParentElementByTagName : function (element, tagName) {
		var element=element;
		while(element.tagName != tagName)
			element = element.parentNode;
		return element;
	}

}

JPAjaxControlToolKit.HierarchicalGridBehavior.registerClass('JPAjaxControlToolKit.HierarchicalGridBehavior', AjaxControlToolkit.BehaviorBase);
