Imports System
Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports AjaxControlToolkit

#Region "Assembly Resource Attribute"
<Assembly: System.Web.UI.WebResource("JPAjaxControlToolKit.HierarchicalGridBehavior.js", "text/javascript")> 
#End Region

Namespace JPAjaxControlToolKit

    <Designer(GetType(HierarchicalGridDesigner))> _
    <ClientScriptResource("JPAjaxControlToolKit.HierarchicalGridBehavior", "JPAjaxControlToolKit.HierarchicalGridBehavior.js")> _
    <TargetControlType(GetType(Control))> _
    Public Class HierarchicalGridExtender 
        Inherits ExtenderControlBase

        Private _linha As GridViewRow
        Private _imagem As Image

        Private _panelToCollapse As Panel
        <ExtenderControlProperty()> _
        <DefaultValue("")> _
        <IDReferenceProperty(GetType(Panel))> _
        Public Property PanelToCollapse() As String
            Get
                Return GetPropertyValue("PanelToCollapse", String.Empty)
            End Get
            Set(ByVal value As String)
                SetPropertyValue("PanelToCollapse", value)
            End Set
        End Property

        <Category("Appearance")> _
        <Description("URL da imagem a ser exibida quando expandido.")> _
        <UrlProperty()> _
        <Browsable(True)> _
        <Bindable(True)> _
        <DefaultValue("")> _
        <Editor("System.Web.UI.Design.ImageUrlEditor, System.Design, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a", _
        GetType(System.Web.UI.Design.ImageUrlEditor))> _
        <ExtenderControlProperty()> _
        Public Property ImageURLExpanded() As String
            Get
                Return GetPropertyValue("ImageURLExpanded", String.Empty)
            End Get
            Set(ByVal value As String)
                SetPropertyValue("ImageURLExpanded", value)
            End Set
        End Property

        <Category("Appearance")> _
        <Description("URL da imagem a ser exibida quando recolhido.")> _
        <UrlProperty()> _
        <Browsable(True)> _
        <Bindable(True)> _
        <DefaultValue("")> _
        <Editor(GetType(System.Web.UI.Design.UrlEditor), _
        GetType(System.Web.UI.Design.ImageUrlEditor))> _
        <ExtenderControlProperty()> _
        Public Property ImageURLCollapsed() As String
            Get
                Return GetPropertyValue("ImageURLCollapsed", String.Empty)
            End Get
            Set(ByVal value As String)
                SetPropertyValue("ImageURLCollapsed", value)
            End Set
        End Property

        <ExtenderControlProperty()> _
        <DefaultValue("")> _
        Public Property Collapsed() As Boolean
            Get
                Return GetPropertyValue("Collapsed", True)
            End Get
            Set(ByVal value As Boolean)
                SetPropertyValue("Collapsed", value)
            End Set
        End Property

        <ExtenderControlProperty()> _
        <DefaultValue("")> _
        <IDReferenceProperty(GetType(GridViewRow))> _
        <ElementReference()> _
        <ClientPropertyName("rowToCollapse")> _
        <Browsable(False)> _
        <Bindable(False)> _
        Public Property Row() As String
            Get
                Return GetPropertyValue("Row", String.Empty)
            End Get
            Set(ByVal value As String)
                SetPropertyValue("Row", value)
            End Set
        End Property

        Private Sub HierarchicalGridExtenderExtender_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            If TypeOf (Me.NamingContainer) Is GridViewRow Then
                _linha = CType(Me.NamingContainer, GridViewRow)
            Else
                Throw New ApplicationException(Me.ClientID & " est fora do GridView.")
            End If

            If _linha.FindControl(Me.PanelToCollapse) IsNot Nothing Then
                _panelToCollapse = CType(_linha.FindControl(Me.PanelToCollapse), Panel)
            Else
                Throw New ApplicationException("Painel " & Me.PanelToCollapse & " no encontrado no GridView.")
            End If
        End Sub

        Private Sub HierarchicalGridExtenderExtender_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
            SetPropertyValue("Image", CType(Me.TargetControl, Image).ClientID)
            SetPropertyValue("PanelToCollapse", _panelToCollapse.ClientID)
            SetPropertyValue("Row", _linha.ClientID)
            SetPropertyValue("ImageURLExpanded", Page.ResolveUrl(Me.ImageURLExpanded))
            SetPropertyValue("ImageURLCollapsed", Page.ResolveUrl(Me.ImageURLCollapsed))
            SetPropertyValue("Collapsed", Me.Collapsed)
        End Sub

    End Class

End Namespace